unit Score;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
    TScore = packed record
        Score: integer;
        Name : ShortString;
        Time : ShortString;
    end;

const
    MAX_COUNT = 10;

type
  TScoreForm = class(TForm)
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Label1Click(Sender: TObject);
  private
    FScores: array[0..MAX_COUNT-1] of TScore;
  public
    FNewScore: integer;
    FNewScoreTime: string;
    FHiScore: integer;
    procedure DispScore(const NewScore: integer);
  end;

var
    ScoreForm: TScoreForm;

implementation

{$R *.dfm}

var
    DataFileName: string = '';

procedure TScoreForm.FormCreate(Sender: TObject);
var
    Count: integer;
    F: file of TScore;
begin
    //  f[^t@C̃pX
    DataFileName := ChangeFileExt(ParamStr(0), '.dat');
    //  f[^
    FillChar(FScores, Length(FScores), #0);
    //  t@CΓǂݍ
    if FileExists(DataFileName) then
    begin
        AssignFile(F, DataFileName);
        Reset(F);
        try
            Count := 0;
            while not Eof(F) do
            begin
                Read(F, FScores[Count]);
                Inc(Count);
                if (Count >= MAX_COUNT) then break;
            end;
        finally
            CloseFile(F);
        end;
    end;
end;

procedure TScoreForm.FormDestroy(Sender: TObject);
var
    i: integer;
    F: file of TScore;
begin
    //  f[^̏
    AssignFile(F, DataFileName);
    Rewrite(F);
    try
        for i := Low(FScores) to High(FScores) do
        begin
            Write(F, FScores[i]);
        end;
    finally
        CloseFile(F);
    end;
end;

procedure TScoreForm.DispScore(const NewScore: integer);
var
    s: string;
begin
    FNewScore := NewScore;
    FNewScoreTime := FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);

    if FHiScore < FNewScore then
    begin
        FHiScore := FNewScore;
        s := 'GOOD JOB!';
    end
    else
    begin
        s := 'TRY AGAIN.';
    end;
    s := s + Format(' > %6.6d', [NewScore]);
    Label1.Caption := s;

    Self.ShowModal();
end;

procedure TScoreForm.Label1Click(Sender: TObject);
begin
    Close();
end;

end.

